#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int mod = 1e9 + 9;

void solve() {
    int n, k;
    cin >> n >> k;
    if (k == 0) {
        cout << 1;
        return;
    }
    vector<vector<vector<int> > > dp(n + 1, vector<vector<int> > (k + 1, vector<int> (2, 0)));
    dp[0][0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= k; j++) {
            dp[i][j][0] += dp[i - 1][j][0];
            dp[i][j][0] %= mod;
            dp[i][j][1] += dp[i - 1][j][1];
            dp[i][j][1] %= mod;
        }
        for (int j = 0; j <= k - 2; j++) {
            dp[i][j + 1][0] += dp[i - 1][j][0];
            dp[i][j + 1][0] %= mod;
            dp[i][j + 1][1] += dp[i - 1][j][1];
            dp[i][j + 1][1] %= mod;
        }
        dp[i][k][1] += (dp[i - 1][k - 1][0] + dp[i - 1][k - 1][1]);
        dp[i][k][1] %= mod;
        dp[i][k - 1][1] += dp[i - 1][k][1];
        dp[i][k - 1][1] %= mod;
        for (int j = k - 1; j >= 1; j--) {
            dp[i][j - 1][0] += dp[i - 1][j][0];
            dp[i][j - 1][0] %= mod;
            dp[i][j - 1][1] += dp[i - 1][j][1];
            dp[i][j - 1][1] %= mod;
        }
    }
    cout << dp[n][0][1];
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
